local addonName = "ZigboKnowsJokes"
local update_sec = 0;
local zigboKnowsInstance = nil
local configPanel = nil
local isInitialized = false

local jokes = {}

local function ZigboKnowsJokes_Update_Handler(self, elapsed)
	update_sec = update_sec + elapsed
	
	if (isInitialized == true) then
		if (update_sec > tonumber(ZigboKnowsJokes_Vars["jokePeriod"])) then 
			
			local msg = zigboKnowsInstance:CreateMessage("|cff69CCF0Random Joke!|r<br><br>" .. jokes[math.random(#jokes)])
			msg:SetActiveTime(30)
			zigboKnowsInstance:RequestShowMessage(msg)	
					
			update_sec = 0
		end
	end

end

local function checkSavedVariables()
	if (ZigboKnowsJokes_Vars == nil) then
		ZigboKnowsJokes_Vars = {}
	end
	
	if (ZigboKnowsJokes_Vars["jokePeriod"] == nil) then
		ZigboKnowsJokes_Vars["jokePeriod"] = "300"
	end

end

local function ZigboKnowsJokes_Event_Handler(self, event, ...)	
	if (event == "ADDON_LOADED" and ... == addonName) then
		zigboKnowsInstance = ZigboKnows:GetInstance(addonName)
		zigboKnowsInstance:SetPortrait(21362, 1.8, 0.0, 0.15) -- Bananas
		
		checkSavedVariables()
		isInitialized = true
		
		configPanel = ZigboKnows.config:CreateChildPanel("Jokes")
		
		configPanel.jokePeriodLabel = ZigboKnows.config:FontString_Create(configPanel, 10, -10, "Period between jokes")
		configPanel.jokePeriod = ZigboKnows.config:DropDown_Create(configPanel, "jokePeriod", 10, -25, 100, {"60", "120", "180", "240", "300", "360", "420", "480", "540", "600"}, ZigboKnowsJokes_Vars)
		
	end
end


function ZigboKnowsJokes_Init()
	local frame = CreateFrame("FRAME", "ZigboKnowsQuestsFrame")
	
	frame:RegisterEvent("ADDON_LOADED")
	
	frame:SetScript("OnEvent", ZigboKnowsJokes_Event_Handler)
	frame:SetScript("OnUpdate", ZigboKnowsJokes_Update_Handler)
	
	
	-- Adding jokes to table.concat
	jokes[#jokes + 1] = "Why didn't the warrior cross the road?<br>No path available."
	jokes[#jokes + 1] = "What's a rogue's favourite drink?<br>Subtle tea."
	jokes[#jokes + 1] = "How does Naxxramas fly?<br>With its four wings."
	jokes[#jokes + 1] = "How do you know someone's been playing since Vanilla?<br>Don't worry, they'll tell you."
	jokes[#jokes + 1] = "How does a tauren hide in a cherry bush?<br>He paints his hooves red."
	jokes[#jokes + 1] = "What do you call five mogu rolling down the hill?<br>The Rolling Stones!"
	jokes[#jokes + 1] = "What do you call it if paladins and druids share a bath?<br>A HoT tub full of Bubbles."
	jokes[#jokes + 1] = "How many rogues does it take to kill a paladin?<br>Two. One to ambush him, one to wait at his hearthstone location."
	jokes[#jokes + 1] = "My warrior is so arms ... it doesn't have legs."
	jokes[#jokes + 1] = "Why did the enchanter have to clean out his bank?<br>Because it was full of dust!"
	jokes[#jokes + 1] = "Why are warriors the worst salesman?<br>They charge too much!"
	jokes[#jokes + 1] = "Deathwing in Thunderbluff? Cattle-clysm."
	jokes[#jokes + 1] = "If you wouldn't stand in fire in real life?<br>Why would you stand in fire in a game?"
	jokes[#jokes + 1] = "Why do orcs make the best gardeners?<br>They all have green thumbs."
	jokes[#jokes + 1] = "Why didn't the undead cross the road?<br>He just didn't have the guts!"
	jokes[#jokes + 1] = "Why do hardcore raiders smell so awful?<br>They don't wipe!"
	jokes[#jokes + 1] = "In what way are artists and healers alike?<br>The aren't appreciated for their work until after they die!"
	jokes[#jokes + 1] = "What do rogues and noobs have in common?<br>They both pick locks!"
	jokes[#jokes + 1] = "Why do developers always fail at gymnastics?<br>They suck at balancing."
	jokes[#jokes + 1] = "Why did the mage have sore eyes?<br>Because his blink didn't do anything."
	jokes[#jokes + 1] = "Why do restoration druids hate math?<br>Because they just don't get square roots."
	jokes[#jokes + 1] = "How many gnomes do you need to paint a wall?<br>Depens on how hard you throw them."
	jokes[#jokes + 1] = "Why do many girls pick druids?<br>So they can purr like a kitten 3 weeks/month and rage like a bear the 4th."
	jokes[#jokes + 1] = "Arthas and Uther walk into a building, Arthas asks 'what is that switch for?'<br>Uther: FOR THE LIGHT!"
	jokes[#jokes + 1] = "What's tauren's most famous racial? They can't pass through doors."
	jokes[#jokes + 1] = "What's the difference between hookers and death knights?<br>Nothing, they're both cheap and spread diseases."
	jokes[#jokes + 1] = "What do you get if you cross a gnome and a tauren?<br>A mini-taur."
	jokes[#jokes + 1] = "What do you call a gnome mage?<br>Minibar."
	jokes[#jokes + 1] = "How do you stop a warrior from charging?<br>You take away his credit card!"
	jokes[#jokes + 1] = "What's black and white and red all over?<br>A pandaren after a bloodbath."
	jokes[#jokes + 1] = "Where does Ragnaros go for his back treatments?<br>The pyro-practor."
	jokes[#jokes + 1] = "What do you call a tauren rogue?<br>Invisibull!"
	jokes[#jokes + 1] = "What is the sound a GM makes when answering a ticket?<br>I don't know, but i will tell you in 37 days when I get a response."
	jokes[#jokes + 1] = "Tauren rogues are the best rogues in Azeroth.<br>Seriously, have you ever seen one? Yeah thought so."
	jokes[#jokes + 1] = "Some female rogues are beautiful. However all of them are stunning."
	jokes[#jokes + 1] = "What do rogues and Mantid have in common?<br>They both love sap."
	jokes[#jokes + 1] = "What does a Banshee wear in the winter?<br>Booooooooots!"
	jokes[#jokes + 1] = "A dwarf walks out of a bar..."
	jokes[#jokes + 1] = "How many dwarves does it take to screw in a lightbulb?<br>Two. One to hold the lightbulb in place and one to drink until the room starts spinning."
	jokes[#jokes + 1] = "Why did Ragnaros buy an alarm clock?<br>Because Executus kept getting him up 'TOO SOON!!!'"
	jokes[#jokes + 1] = "How many rogues does it take to screw in a lightbulb?<br>One to screw in the bulb and 99 to post on forums claiming they could've done it better."
	jokes[#jokes + 1] = "Hey babe. What's the drop rate on your pants?"
	jokes[#jokes + 1] = "An orc wlaks into a bar with a parrot on his shoulder. The bartender looks up and says, 'Hey, where'd you get that?!' The parrto replies, 'Durotar. They got'em all over the place!'"
	jokes[#jokes + 1] = "What did the troll priest say to the sexy cloth armor vendor?<br>'Dis robe'"
	jokes[#jokes + 1] = "Two tauren are sitting at a bar. A female tauren passes by and the first tauren says 'moo'. The second tauren says 'I was gonna say that!'"
	jokes[#jokes + 1] = "I'm a Paladin, small and stout,<br>here's my mace and here's my mount,<br>when I see trouble i scream and shout,<br>pop my bubble and hearthstone out..."
	jokes[#jokes + 1] = "Why do only high level warrios and paladins get invited to dinner parties?<br>No one else can use plate."
	jokes[#jokes + 1] = "Why do warriors never get their weapons enchanted with intellect?<br>They don't want their weapons being smarter than they are."
	jokes[#jokes + 1] = "How do most Gnomes die?<br>Picking cherries."
	jokes[#jokes + 1] = "How many Blood Elves does it take to kill a cockroach?<br>Two. A male one to scream like a little girl and a female one to actually kill it."
	jokes[#jokes + 1] = "Knock Knock.<br>Who's there?<br>Interrupting Tauren.<br>Interrupting Tauren W-...?<br>WAR STOMP!"
	jokes[#jokes + 1] = "What's the difference between a Gnome and a trampoline?<br>You take your shoes off to jump on a trampoline."
	
	-- mum's jokes
	jokes[#jokes + 1] = "Your mum's so fat, when she logs in she automatically gets the World Explorer achievement."
	jokes[#jokes + 1] = "Your mum's so fat, when a rogue shadowstepped her, he got loading screen..."
	jokes[#jokes + 1] = "Your mum's so fat, it takes four warlocks to summon her."
	jokes[#jokes + 1] = "Your mum's so fat, she gets hit by chain lightning three times."
	jokes[#jokes + 1] = "Your mum's so fat, when she sat on Black Temple it became Sunken Temple."
	
end
